freeslot("MT_SLIMETRAIL", "S_SLIMETRAIL", "S_SLIMEWALL", "SPR_GOOD")

local function Splash(mo, color)
	for i = 1, 10
		local bomb = P_SpawnMobj(mo.x, mo.y, mo.z+50*FRACUNIT, MT_SLIMETRAIL)
		bomb.color = color
		bomb.state = S_SLIMETRAIL
		bomb.renderflags = RF_FULLBRIGHT
		bomb.flags2 = 0
		P_InstaThrust(bomb, P_RandomRange(0, 360)*ANG1, P_RandomRange(0, 10)*FRACUNIT)
		P_SetObjectMomZ(bomb, P_RandomRange(-5, 5)*FRACUNIT)
		if mo.eflags & MFE_VERTICALFLIP
			bomb.eflags = $|MFE_VERTICALFLIP
			bomb.flags2 = $|MF2_OBJECTFLIP
		else
			bomb.eflags = $ & ~MFE_VERTICALFLIP
			bomb.flags2 = $ & ~MF2_OBJECTFLIP
		end
	end	
end

local EMOTE_DEFAULT = 0
local EMOTE_HAPPY = 1
local EMOTE_ANGRY = 2
local EMOTE_SUPRISE = 3
local EMOTE_PAIN = 4
local EMOTE_DEAD = 5
local EMOTE_CRYING = 6
local EMOTE_AFRAID = 7

local emotes = {
	[0] = S_EYESDEF,
	[1] = S_EYESHAPPY,
	[2] = S_EYESANGRY,
	[3] = S_EYESSUPRISE,
	[4] = S_EYESPAIN,
	[5] = S_EYESDEAD,
	[6] = S_EYESCRYING,
	[7] = S_EYESAFRAID
}

local function DeletusFOFus(mo, sec)
  for fof in sec.ffloors()
    if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
    if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
    
    if mo.z + mo.height < fof.bottomheight continue end -- Are we too low?
    if mo.z > fof.topheight continue end -- Are we too high? 
	
	EV_CrumbleChain(fof)
  end
end

addHook("PlayerThink", function(p)
  if not p.mo return end
  if (p.mo.skin != "rimuru") return end
  if (p.mo.scale <= FRACUNIT) return end

  DeletusFOFus(p.mo, p.mo.subsector.sector)
end)

addHook("MobjLineCollide", function(mo, line)
  if not mo.player return end
  if (mo.skin != "rimuru") return end
   if (mo.player.mo.scale <= FRACUNIT) return end

  for _, sec in ipairs({line.frontsector, line.backsector})
    DeletusFOFus(mo, sec)
  end
end, MT_PLAYER)

addHook("ShieldSpecial", function(player)
	if player.valid and player.playerstate == PST_LIVE and player.mo.skin == "rimuru"
		return true
	end
end)

local function slimehats(player, arg, arg2)  //Command
	if player.valid
		if arg == nil
		and player.mo.hat
			CONS_Printf(player,'\n"Change hats, default is "none".')
		else
			local value = tonumber(arg)
			local value2 = tonumber(arg2)
			if arg2 != nil
				if value2 < #skincolors and value2 > 0
					player.hatcolor = arg2
				end	
				if value2 == 0
					player.hatcolor = player.mo.color
				end
			else
				player.hatcolor = player.mo.color
			end	
				if arg == "none" or value == 0
					if player.mo.hat
						player.mo.hattype = 0
						player.mo.hat.flags2 = $|MF2_DONTDRAW
					end
				end
				if value == 31
					if player.mo.hat
						player.mo.hat.hattype = 31
						player.mo.hat.flags2 = $ & ~MF2_DONTDRAW
					end
				end
				/*if value == 69
					if player.mo.hat
						player.mo.hat.hattype = 61
						player.mo.hat.flags2 = $ & ~MF2_DONTDRAW
					end
				end*/
		end
	else
		CONS_Printf(player,"You need to exist!")
	end
end	

COM_AddCommand("slimehat", slimehats)

addHook("PlayerThink", function(player)
	if player.mo.skin != "rimuru"
		if player.rimuru == true
			if player.mo.scale > FRACUNIT
				player.mo.scale = FRACUNIT
			end	
		end
	end
	if player.valid and player.playerstate == PST_LIVE and player.mo.skin == "rimuru"
		if player.rotate == nil
			player.rotate = 0
		end
		if player.revertscale and player.revertscale >= FRACUNIT*20
			player.revertscale = FRACUNIT*20
		end
		if player.rimuru == nil
			player.rimuru = false
		end
		player.rimuru = true
		player.powers[pw_spacetime] = 99999
		player.powers[pw_underwater] = 99999
		if not player.eyes
			player.eyes = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_EYES)
			player.eyes.color = player.mo.color
		end
		if player.showskill
			player.showskill = $ - 1
		end
		local slimetarg = P_LookForEnemies(player, true, true)
		if slimetarg and not (player.mo.slimed and slimetarg.slimed)
			P_SpawnLockOn(player, slimetarg, S_SLIMETARGET)
		end
		if player.mo.scale < FRACUNIT and not (player.cmd.buttons & BT_CUSTOM1)
			if (leveltime%10) == 1
				player.mo.scale = $ + FRACUNIT/50
			end	
		end
		local homret = P_LookForEnemies(player, true, false)
		if homret and player.pflags & PF_JUMPED and not (player.pflags & PF_THOKKED)
			local target = P_SpawnMobjFromMobj(homret, 0, 0, 0, MT_OVERLAY)
			target.state = S_SLIMERETICLE
			target.color = player.mo.color
			target.flags = $|MF_NOGRAVITY
			target.fuse = 2
			target.target = homret
			target.scale = FRACUNIT*2
			target.spriteyoffset = -25*FRACUNIT
			target.rollangle = ((leveltime%(360/15))*ANG1)*15
		end
		if player.mo.scale > FRACUNIT*20
			player.mo.scale = FRACUNIT*20
		end
		if player.mo.goback
			player.mo.goback = $ - 1
			if player.mo.goback == 1
				player.mo.momx = player.mo.gobacknum
			end
		end
		if player.cmd.buttons & BT_CUSTOM1
			if player.custom1 == false
			and not player.revert
				player.revertscale = player.mo.scale
				S_StartSound(player.mo, sfx_gspray)
			else
				if player.mo.scale > FRACUNIT - FRACUNIT/3
					player.mo.scale = $ - FRACUNIT/5
					P_SpawnGhostMobj(player.mo)
				end	
				player.revert = true
			end
			
			player.custom1 = true
		else
			if player.revert
				if player.mo.scale < player.revertscale
					player.mo.scale = $ + FRACUNIT/5
					P_SpawnGhostMobj(player.mo)
				else
					player.revert = false
					player.mo.scale = player.revertscale
					S_StartSound(player.mo, sfx_splash)
				end	
			end
			player.custom1 = false
		end
		if player.cmd.buttons & BT_SPIN
			if player.spin == false
			and player.mo.scale >= FRACUNIT - FRACUNIT/3
			and slimetarg and not (player.mo.slimed and slimetarg.slimed)
				player.mo.scale = $ - FRACUNIT/15
				player.slimemissile = P_SpawnMobjFromMobj(player.mo, 0, 0, player.mo.height/2*player.mo.scale, MT_SLIMETRAIL)
				player.slimemissile.fuse = 50
				player.slimemissile.color = player.mo.color
				player.slimemissile.flags = $|MF_NOGRAVITY
				local aim = R_PointToAngle2(player.mo.x, player.mo.y, slimetarg.x, slimetarg.y)
				P_InstaThrust(player.slimemissile, aim, 30*FRACUNIT)
				
				local slimetrail = P_SpawnMobjFromMobj(slimetarg, 0,0, slimetarg.height/2, MT_SLIMETRAIL)
				slimetrail.fuse = 50
				slimetrail.color = player.mo.color
				slimetrail.flags = $|MF_NOGRAVITY
				local aim2 = R_PointToAngle2(slimetarg.x, slimetarg.y, player.mo.x, player.mo.y)
				P_InstaThrust(slimetrail, aim2, 30*FRACUNIT)
				
				slimetarg.slime = true
				slimetarg.colorized = true
				slimetarg.color = player.mo.color
				if slimetarg.scale < FRACUNIT*20
					slimetarg.scale = $ + FRACUNIT/50
				end
				S_StartSound(player.mo, sfx_gspray)
				local slime = P_SpawnMobjFromMobj(player.mo, 0,0, player.mo.height*player.mo.scale, MT_SLIMETRAIL)
				slime.fuse = 50
				slime.color = player.mo.color
				P_SetObjectMomZ(slime, 10*FRACUNIT)
				//player.hand = 15
			end
			if player.spin == false
			and player.mo.scale >= FRACUNIT - FRACUNIT/3
			and not slimetarg
				player.mo.scale = $ - FRACUNIT/15
				player.slimemissile = P_SpawnMobjFromMobj(player.mo, FixedMul(35*player.mo.scale,cos(player.mo.angle-ANGLE_90)), FixedMul(35*player.mo.scale,cos(player.mo.angle-ANGLE_90)), player.mo.height*player.mo.scale, MT_SLIMETRAIL)
				player.slimemissile.fuse = 50
				player.slimemissile.color = player.mo.color
				player.slimemissile.flags = $|MF_NOGRAVITY 
				player.momangle2 = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
				if not player.speed
					player.momangle2 = player.mo.angle
				end
				P_Thrust(player.mo, player.momangle2, 5*FRACUNIT)
				P_InstaThrust(player.slimemissile, player.momangle2+ANGLE_180, 10*player.mo.scale)
				S_StartSound(player.mo, sfx_gspray)
				local slime = P_SpawnMobjFromMobj(player.mo, 0,0, player.mo.height*player.mo.scale, MT_SLIMETRAIL)
				slime.fuse = 50
				slime.color = player.mo.color
				P_SetObjectMomZ(slime, 10*FRACUNIT)
			end
			player.spin = true
		else
			player.spin = false
		end
		if not player.mo.hat
			player.mo.hat = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SLIMEHAT)
			player.mo.hat.color = player.mo.color
		end
		if player.mo.hat
			local hatx = player.mo.x + FixedMul(22*player.mo.scale, cos(player.mo.angle))
			local haty = player.mo.y + FixedMul(22*player.mo.scale, sin(player.mo.angle))
			
			local headphonesx1 = player.mo.x+FixedMul(20*player.mo.scale, cos(player.mo.angle-ANGLE_90)) 
			local headphonesy1 = player.mo.y+FixedMul(20*player.mo.scale, sin(player.mo.angle-ANGLE_90)) 
			
			local headphonesx2 = player.mo.x+FixedMul(20*player.mo.scale, cos(player.mo.angle+ANGLE_90)) 
			local headphonesy2 = player.mo.y+FixedMul(20*player.mo.scale, sin(player.mo.angle+ANGLE_90)) 
			
			if player.mo.hat.hattype == nil
				player.mo.hat.hattype = 0
			end
			player.mo.hat.scale = player.mo.scale
			if player.mo.hat.flags2 & MF2_DONTDRAW
			and not (player.mo.flags & MF2_DONTDRAW)
				player.mo.hat.flags2 = $ & ~MF2_DONTDRAW
			end
			if player.mo.hat.hattype == 0
				if not (player.mo.hat.flags2 & MF2_DONTDRAW)
					player.mo.hat.flags2 = $|MF2_DONTDRAW
				end
			else	
				if player.mo.hat.hattype == 31
					player.mo.hat.state = S_SPOOKYSLIMEHAT
					player.mo.hat.momx = player.mo.momx
					player.mo.hat.momy = player.mo.momy
					player.mo.hat.momz = player.mo.momz
					player.mo.hat.color = player.hatcolor
					player.mo.hat.angle = player.mo.angle+ANGLE_90
					P_TeleportMove(player.mo.hat, hatx, haty, player.mo.z)
					player.mo.hat.scale = ((FRACUNIT + FRACUNIT/15)/FRACUNIT)*player.mo.scale
				end
				if player.mo.hat.hattype == 69
					player.mo.hat.state = S_SLIMEHEADNPHONES1
					player.mo.hat.color = player.hatcolor
					player.mo.hat.angle = player.mo.angle
					
					local ghost = P_SpawnGhostMobj(player.mo.hat)
					ghost.state = S_SLIMEHEADPHONES2
					ghost.angle = player.mo.angle
					ghost.momx = player.mo.momx
					ghost.momy = player.mo.momy
					ghost.momz = player.mo.momz
					P_TeleportMove(player.mo.hat, headphonesx1, headphonesy1, player.mo.z + (player.mo.height - (FRACUNIT/15)))
					P_TeleportMove(ghost, headphonesx2, headphonesy2, player.mo.z + (player.mo.height - (FRACUNIT/15)))
					player.mo.hat.momx = player.mo.momx
					player.mo.hat.momy = player.mo.momy
					player.mo.hat.momz = player.mo.momz
				end
			end
		end
		if player.eyes and player.eyes.valid
			player.eyes.color = player.mo.color
			player.eyes.angle = $ + ((player.mo.angle - player.eyes.angle)+ANGLE_90)
			player.eyes.momx = player.mo.momx
			player.eyes.momy = player.mo.momy
			player.eyes.momz = player.mo.momz
			player.eyes.scale = player.mo.scale
			
			if player.eyes.flags2 & MF2_DONTDRAW
			and not (player.mo.flags & MF2_DONTDRAW)
				player.eyes.flags2 = $ & ~MF2_DONTDRAW
			end
			
			if player.emote == 3 or player.emote == 2
				local emotepaper = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_EYES)
				emotepaper.momx = player.mo.momx
				emotepaper.momy = player.mo.momy
				emotepaper.momz = player.mo.momz
				emotepaper.angle = (player.mo.angle+ANGLE_90)+1*ANG1
				emotepaper.scale = player.mo.scale
				emotepaper.color = player.mo.color
				emotepaper.fuse = 2
				if player.emote == 2
					emotepaper.state = S_EMOTEEXC
				end
				if player.emote == 3
					emotepaper.state = S_EMOTEQUS
				end
			end
			if player.emote == 4 or player.emote == 5
				local hurtoverlay = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_OVERLAY)
				hurtoverlay.target = player.mo
				hurtoverlay.state = S_EMOTEHURT
				hurtoverlay.momx = player.mo.momx
				hurtoverlay.momy = player.mo.momy
				hurtoverlay.momz = player.mo.momz
				hurtoverlay.angle = (player.mo.angle+ANGLE_90)+1*ANG1
				hurtoverlay.scale = player.mo.scale
				hurtoverlay.color = player.mo.color
				hurtoverlay.fuse = 2
			end
			if player.hand
				player.hand = $ - 1
				local paperhand = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_EYES)
				paperhand.momx = player.mo.momx
				paperhand.momy = player.mo.momy
				paperhand.momz = player.mo.momz
				paperhand.angle = (player.mo.angle+ANGLE_90)+1*ANG1
				paperhand.scale = player.mo.scale
				paperhand.color = player.mo.color
				paperhand.fuse = 2
				paperhand.state = S_SLIMEHAND
			end
			
			if player.emote
				player.eyes.state = emotes[player.emote]
			else
				player.eyes.state = S_EYESDEF
			end
			
			local gotox = player.mo.x + FixedMul(20*player.mo.scale, cos(player.mo.angle))
			local gotoy = player.mo.y + FixedMul(20*player.mo.scale, sin(player.mo.angle))
			local eyesview = (player.aiming/ANG1*FRACUNIT)/8
			
			P_TeleportMove(player.eyes, gotox, gotoy, player.mo.z+eyesview)
			
			if gametype == GT_COOP or gametype == GT_COMPETITION or gametype == GT_RACE
				if (player.cmd.buttons & BT_WEAPONMASK)
					if not player.weaponchange
						if not player.emote 
							local weapon = player.cmd.buttons & BT_WEAPONMASK
							player.emote = weapon
						else
							player.emote = 0
						end
					end	
					player.weaponchange = true
				else
					player.weaponchange = false
				end
			end
		end
		player.rotate = $ + player.speed/FRACUNIT
		if not (player.powers[pw_carry] == CR_NIGHTSMODE)
			if P_IsObjectOnGround(player.mo)
				if player.speed > FRACUNIT
					player.mo.spritexscale = (FRACUNIT+FRACUNIT/15) + FixedMul(cos(player.rotate*ANG1), FRACUNIT/15)
				else
					player.mo.spritexscale = FRACUNIT
				end	
				player.mo.spriteyscale = FRACUNIT
			else
				if player.mo.momz > -10*FRACUNIT
					player.mo.spritexscale = FRACUNIT - FixedMul(sin(player.mo.momz/FRACUNIT*ANG1), FRACUNIT/2)
					player.mo.spriteyscale = FRACUNIT + FixedMul(sin(player.mo.momz/FRACUNIT*ANG1), FRACUNIT/2)
				else
					player.mo.spritexscale = FRACUNIT + FixedMul(sin(player.mo.momz/FRACUNIT*ANG1), FRACUNIT/2)
					player.mo.spriteyscale = FRACUNIT - FixedMul(sin(player.mo.momz/FRACUNIT*ANG1), FRACUNIT/2)
				end
			end
			if player.pflags & PF_JUMPED
				if not player.mo.slimed
					local trail = P_SpawnMobjFromMobj(player.mo, 0, 0, 0, MT_SLIMETRAIL)
					trail.state = S_SLIMETRAIL
					trail.fuse = 2
					trail.color = player.mo.color
					trail.trail = true
					trail.spritexscale = FRACUNIT + FRACUNIT/2
				else
					local trail = P_SpawnMobj(player.mo.x, player.mo.y, player.mo.z, MT_OVERLAY)
					trail.state = S_SLIMETRAIL
					trail.fuse = 2
					trail.color = player.mo.color
					trail.trail = true
					trail.scale = FRACUNIT*2
					trail.target = player.mo.slimed
				end	
			end
			if player.mo.slimed
				P_TeleportMove(player.mo.slimed, player.mo.x, player.mo.y, player.mo.z)
				player.mo.slimed.scale = $ - FRACUNIT/15
				player.mo.slimed.colorized = true
				player.mo.slimed.color = player.mo.color
				player.target = P_LookForEnemies(player, false, false)
				local bubbles = {
				sfx_bubbl1,
				sfx_bubbl2,
				sfx_bubbl3,
				sfx_bubbl4,
				sfx_bubbl5}
				local spike = (player.mo.slimed.type == MT_SPIKE or player.mo.slimed.type == MT_WALLSPIKE or player.mo.slimed.type == MT_WALLSPIKEBASE)
				S_StartSound(player.mo, bubbles[P_RandomRange(1, 5)])
				if player.mo.slimed.scale <= FRACUNIT/15
					if not (player.cmd.buttons & BT_CUSTOM1)
						if player.mo.slimed.startscale
							if not spike
								player.mo.scale = $ + (FRACUNIT/5) + (player.mo.slimed.startscale-FRACUNIT)
							else
								player.mo.scale = $ + (FRACUNIT/100) + (player.mo.slimed.startscale-FRACUNIT)
							end	
						else
							if not spike
								player.mo.scale = $ + (FRACUNIT/5)
							else
								player.mo.scale = $ + (FRACUNIT/100)
							end	
						end	
					else
						if player.mo.slimed.startscale
							if not spike
								player.revertscale = $ + (FRACUNIT/5) + (player.mo.slimed.startscale-FRACUNIT)
							else
								player.revertscale = $ + (FRACUNIT/100) + (player.mo.slimed.startscale-FRACUNIT)
							end	
						else
							if not spike
								player.revertscale = $ + (FRACUNIT/5)
							else
								player.revertscale = $ + (FRACUNIT/100)
							end	
						end	
					end	
					P_KillMobj(player.mo.slimed, player.mo, player.mo)
					player.mo.slimed.slimed = nil
					player.mo.slimed = nil
					player.mo.flags2 = $ & ~MF2_DONTDRAW
					//P_SetObjectMomZ(player.mo, -10*FRACUNIT)
					player.eyes.flags2 = $ & ~MF2_DONTDRAW
					S_StartSound(player.mo, sfx_bnce2)
				end
			end
		end
	end
end)

addHook("AbilitySpecial", function(player)
	if player.valid and player.playerstate == PST_LIVE and player.mo.skin == "rimuru"
		player.target = P_LookForEnemies(player, true, false)
		if not (player.pflags & PF_THOKKED)
			if player.target
				if player.mo.scale >= FRACUNIT
				and not player.target.slime
					player.mo.scale = $ - FRACUNIT/5
					player.target.slime = true
					player.target.colorized = true
					player.target.color = player.mo.color
					if player.target.scale < FRACUNIT*20
						player.target.scale = $ + FRACUNIT/50
					end
					Splash(player.target, player.mo.color)
				end
				if player.target.slime
					local slime = P_SpawnMissile(player.mo, player.target, MT_SLIMETRAIL)
					slime.state = S_SLIMETRAIL
					slime.fuse = 15
					slime.color = player.mo.color
					
					local slime2 = P_SpawnMissile(player.target, player.mo, MT_SLIMETRAIL)
					slime2.state = S_SLIMETRAIL
					slime2.fuse = 15
					slime2.color = player.mo.color
					
					P_HomingAttack(player.mo, player.target)
					S_StartSound(player.mo, sfx_splish)
				end	
			else
				P_SpawnGhostMobj(player.mo)
				S_StartSound(player.mo, sfx_bnce2)
				player.mo.scale = $ - FRACUNIT/5
				player.slimemissile = P_SpawnMobjFromMobj(player.mo, FixedMul(35*player.mo.scale,cos(player.mo.angle-ANGLE_180)), FixedMul(35*player.mo.scale,cos(player.mo.angle-ANGLE_180)), player.mo.height*player.mo.scale, MT_SLIMETRAIL)
				player.slimemissile.fuse = 50
				player.slimemissile.color = player.mo.color
				player.slimemissile.flags = $|MF_NOGRAVITY 
				player.momangle2 = R_PointToAngle2(0, 0, player.mo.momx, player.mo.momy)
				if not player.speed
					player.momangle2 = player.mo.angle
				end
				P_Thrust(player.mo, player.momangle2, 5*FRACUNIT)
			end
			player.pflags = $|PF_THOKKED
		end	
	end
end)

addHook("MobjThinker", function(mo)
	if mo.valid
	and mo.state == S_SLIMETRAIL
		if mo.gosmol
			mo.scale = $ - FRACUNIT/15
			mo.spritexscale = $ - FRACUNIT/15
		end	
		if not mo.trail
			local slime = P_SpawnMobjFromMobj(mo, 0, 0, mo.height/2, MT_SLIMETRAIL)
			slime.state = S_SLIMETRAIL
			slime.fuse = 5
			slime.trail = true
			slime.gosmol = true
			slime.color = mo.color
		end
	end
	if mo.valid and (mo.flags & MF_ENEMY or mo.flags & MF_BOSS or mo.flags & MF_MONITOR)
		if mo.slimed
			P_SetObjectMomZ(mo, FRACUNIT)
			mo.flags = $|MF_NOCLIPTHING
			if mo.colorized != true
			and mo.health > 0
				P_KillMobj(mo)
			end
		end
	end
end)

addHook("ShouldDamage", function(mobj, mo, source, damage, damagetype)
	if mobj.type == MT_PLAYER and source == mo and not (damagetype == DMG_INSTAKILL or damagetype == DMG_CRUSHED)
	and mo
		if (mobj.scale > mo.scale+FRACUNIT/4)
			if not mo.slime
				mo.slime = true
				mo.colorized = true
				mo.color = mobj.color
				if mo.scale < FRACUNIT*20
					mo.scale = $ + FRACUNIT/50
				end
				Splash(mo, mobj.color)
			end
			if mobj.player.cmd.buttons & BT_CUSTOM2
				mobj.slimed = mo
				mo.slimed = mobj
				mobj.startscale = mobj.scale
				S_StartSound(mo, sfx_splish)
			end	
			return false
		end	
		if mo.slimed and mobj.slimed
			return false
		end
	end
	if mobj.type == MT_PLAYER and source == mo and not (damagetype == DMG_INSTAKILL or damagetype == DMG_CRUSHED)
	and mo
		if (mobj.type == MT_SPIKE or mobj.type == MT_WALLSPIKE or mobj.type == MT_WALLSPIKEBASE)
			mobj.slimed = mo
			mo.slimed = mobj
			mobj.startscale = mobj.scale
			S_StartSound(mo, sfx_splish)
			return false
		end
	end
	if mobj.flags & MF_ENEMY or mobj.flags & MF_BOSS or mobj.flags & MF_MONITOR and mobj.health > 0
	and not (mobj.slimed or mo.slimed)
		if mo.skin == "rimuru" and source == mo
			if mo.player.pflags & PF_JUMPED
				if not mobj.slimed
					if not (mobj.flags & MF_BOSS)
						mo.goback = 4
						mo.gobacknum = mo.momx
						mobj.slimed = mo
						mo.slimed = mobj
						S_StartSound(mo, sfx_splish)
						mobj.startscale = mobj.scale
						return false
					else
						local bounce = P_SpawnMobjFromMobj(mo, 0, 0, 0, MT_SLIMETRAIL)
						bounce.trail = true
						bounce.fuse = 50
						bounce.scale = FRACUNIT*3
						bounce.flags = $|MF_NOGRAVITY
						bounce.color = mo.color
						bounce.frame = $|FF_PAPERSPRITE
						local anglefix = R_PointToAngle2(mo.x, mo.y, mobj.x, mobj.y)
						bounce.angle = anglefix+ANGLE_90
						S_StartSound(bounce, sfx_bnce1)
						P_InstaThrust(mo, anglefix+ANGLE_180, mo.player.speed)
						return true
					end	
					return false
				end
				return false
			end	
		end
	end
end)

addHook("MobjDamage", function(mo)
	if mo.skin == "rimuru"
		if mo.slimed
			if mo.slime.slimed
				mo.slimed.slimed = nil
			end	
			mo.slimed = nil
		end
		Splash(mo, mo.color)
		mo.scale = $ - FRACUNIT/5
	end	
end, MT_PLAYER)

addHook("MobjDeath", function(mo)
	if mo.skin == "rimuru"
		if mo.slimed
			mo.slimed.slimed = nil
			mo.slimed = nil
		end
		mo.flags2 = $|MF2_DONTDRAW
		mo.player.eyes.flags2 = $|MF2_DONTDRAW
		mo.hat.flags2 = $|MF2_DONTDRAW
		Splash(mo, mo.color)
	end	
end, MT_PLAYER)

/*addHook("MobjDamage", function(mobj, mo)
	if mobj.flags & MF_ENEMY or mobj.flags & MF_BOSS or mobj.flags & MF_MONITOR and mobj.health > 0
		if mo.tracer and mo.type == MT_SLIMETRAIL
			local joinangle = R_PointToAngle2(mobj.x, mobj.y, mo.tracer.x, mo.tracer.y)
		
			local join = P_SpawnMobjFromMobj(mobj, 0, 0, mo.height/2, MT_SLIMETRAIL)
			join.fuse = 50
			join.color = mo.color
			P_InstaThrust(join, joinangle, 15*FRACUNIT)
			mo.tracer.scale = $ + FRACUNIT/15
			P_DamageMobj(mobj, mo.tracer, mo.tracer)
			P_KillMobj(mo)
		end
	end
end)*/

addHook("PlayerSpawn", function(player)
	if player.mo.skin == "rimuru"
		if player.mo.slimed
			if player.mo.slimed.slimed
				player.mo.slimed.slimed = nil
			end	
			player.mo.slimed = nil
		end	
		if player.eyes
			player.eyes = nil
		end
	end
end)

/*addHook("MobjThinker", function(mo)
	if mo.tracer
		local dist = R_PointToDist2(mo.x, mo.y, mo.target.x, mo.target.y)
		if dist > 500*FRACUNIT
			P_HomingAttack(mo, mo.tracer)
		else
			P_HomingAttack(mo, mo.target)
		end
	end
end, MT_SLIMETRAIL)

addHook("MobjFuse", function(mo)
	if mo.tracer
		if mo.tracer.slimemissile
			mo.tracer.slimemissile = nil
		end
	end
end, MT_SLIMETRAIL)*/